import { RxState } from '@rx-angular/state';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare type ValuesOf<O> = O[keyof O];
export declare type KeysOf<O> = keyof O;
declare type InstanceOrType<T> = T extends abstract new (...args: any) => infer R ? R : T;
declare type InferArguments<T> = T extends (...args: infer R) => any ? R : never;
declare type Select<U, K> = K extends keyof U ? U[K] : never;
declare type ExtractString<T extends object> = Extract<keyof T, string>;
declare type FunctionParamsOrValueType<U, K, F> = InferArguments<Select<U, K>> extends never ? [F] : InferArguments<Select<U, K>>;
export declare type Actions = {};
export declare type ActionTransforms<T extends {}> = Partial<{
    [K in keyof T]: (...args: any[]) => T[K];
}>;
export declare type ActionDispatchFn<O extends unknown[]> = (...value: InstanceOrType<O>) => void;
export declare type ActionDispatchers<T extends Actions, U extends {}> = {
    [K in keyof T]: ActionDispatchFn<FunctionParamsOrValueType<U, K, Select<T, K>>>;
};
export declare type ActionObservables<T extends Actions> = {
    [K in ExtractString<T> as `${K}$`]: Observable<InstanceOrType<T[K]>>;
};
export declare type RxActions<T extends Actions, U extends {} = T> = ActionDispatchers<T, U> & ActionObservables<T>;
export declare class EnhancedRxState<T extends object = {}, TActions extends object = {}> extends RxState<T> {
    private subjects;
    private effect$;
    private effectSubscription;
    ngOnDestroy(): void;
    create<U extends ActionTransforms<TActions> = {}>(transforms?: U): RxActions<TActions, U>;
    destroy(): void;
    holdEffect<S>(obsOrObsWithSideEffect: Observable<S>, sideEffectFn: (value: S, firstRun: boolean) => ((previousValue: S | undefined, isUnsubscribed: boolean) => void) | void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EnhancedRxState<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EnhancedRxState<any, any>, never, never, {}, {}, never>;
}
export declare function capitalize<T extends string>(str: T): Capitalize<T>;
export {};
