import { EventEmitter, NgZone, OnChanges, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtObject3dController } from '../controllers/object-3d.controller';
import { AnyConstructor } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtHelper<THelper extends THREE.Object3D> implements OnInit, OnChanges {
    #private;
    protected objectController: NgtObject3dController;
    protected ngZone: NgZone;
    ready: EventEmitter<THelper>;
    abstract helperType: AnyConstructor<THelper>;
    protected set helperArgs(v: unknown | unknown[]);
    constructor(objectController: NgtObject3dController, ngZone: NgZone);
    ngOnChanges(): void;
    ngOnInit(): void;
    get helper(): THelper;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtHelper<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtHelper<any>, never, never, {}, { "ready": "ready"; }, never>;
}
