import { NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtAnimationFrameStore } from '../stores/animation-frame.store';
import { EnhancedRxState } from '../stores/enhanced-rx-state';
import { NgtStore } from '../stores/store';
import { AnyConstructor, AnyFunction } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtObjectHelper<TObjectHelper extends THREE.Object3D> extends EnhancedRxState<{
    args: unknown[];
}> implements OnInit {
    #private;
    protected object3dFn: AnyFunction<THREE.Object3D>;
    protected store: NgtStore;
    protected animationFrameStore: NgtAnimationFrameStore;
    protected ngZone: NgZone;
    abstract objectHelperType: AnyConstructor<TObjectHelper>;
    protected set objectHelperArgs(v: unknown | unknown[]);
    constructor(object3dFn: AnyFunction<THREE.Object3D>, store: NgtStore, animationFrameStore: NgtAnimationFrameStore, ngZone: NgZone);
    ngOnInit(): void;
    get objectHelper(): TObjectHelper | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectHelper<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtObjectHelper<any>, never, never, {}, {}, never>;
}
