import { NgtCommonMesh, NgtMatrix4, NgtObject3dController, NgtObject3dInputsController } from '@angular-three/core';
import { EventEmitter, NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import * as i0 from "@angular/core";
import * as i1 from "@angular-three/core";
export declare class NgtSkinnedMesh extends NgtCommonMesh<THREE.SkinnedMesh> {
    set args(v: [boolean]);
    bindMatrix?: NgtMatrix4;
    bindMode?: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMesh, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtSkinnedMesh, "ngt-skinned-mesh", ["ngtSkinnedMesh"], { "args": "args"; "bindMatrix": "bindMatrix"; "bindMode": "bindMode"; }, {}, never>;
}
export declare class NgtSkeleton implements OnInit {
    #private;
    private ngZone;
    private skinnedMesh;
    boneInverses?: NgtMatrix4[];
    ready: EventEmitter<THREE.Skeleton>;
    get skeleton(): THREE.Skeleton | undefined;
    constructor(ngZone: NgZone, skinnedMesh: NgtSkinnedMesh);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkeleton, [null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtSkeleton, "ngt-skeleton", ["ngtSkeleton"], { "boneInverses": "boneInverses"; }, { "ready": "ready"; }, never>;
}
export declare class NgtBone implements OnInit {
    #private;
    private objectController;
    private objectInputsController;
    private ngZone;
    private parentSkinnedMesh;
    private parentSkeleton;
    ready: EventEmitter<THREE.Bone>;
    get bone(): THREE.Bone | undefined;
    constructor(objectController: NgtObject3dController, objectInputsController: NgtObject3dInputsController, ngZone: NgZone, parentSkinnedMesh: NgtSkinnedMesh, parentSkeleton: NgtSkeleton);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtBone, [null, null, null, { optional: true; }, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtBone, "ngt-bone", ["ngtBone"], {}, { "ready": "ready"; }, never>;
}
export declare class NgtSkinnedMeshModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMeshModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtSkinnedMeshModule, [typeof NgtSkinnedMesh, typeof NgtBone, typeof NgtSkeleton], never, [typeof NgtSkinnedMesh, typeof NgtBone, typeof NgtSkeleton, typeof i1.NgtMaterialGeometryControllerModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtSkinnedMeshModule>;
}
