"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const devkit_1 = require("@nrwl/devkit");
const versions_1 = require("./versions");
function default_1(tree) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
        devkit_1.logger.info('Initializing @angular-three/core...');
        (0, devkit_1.addDependenciesToPackageJson)(tree, {
            three: versions_1.THREE_VERSION,
        }, {
            '@types/three': versions_1.THREE_TYPES_VERSION,
        });
        const tsConfigPath = tree.exists('tsconfig.base.json')
            ? 'tsconfig.base.json'
            : 'tsconfig.json';
        // Turn on skipLibCheck for three-stdlib etc...
        (0, devkit_1.updateJson)(tree, tsConfigPath, (json) => {
            var _a;
            if (!('skipLibCheck' in json.compilerOptions) ||
                ((_a = json.compilerOptions) === null || _a === void 0 ? void 0 : _a.skipLibCheck) === false) {
                json.compilerOptions.skipLibCheck = true;
            }
            return json;
        });
        return () => {
            (0, devkit_1.installPackagesTask)(tree);
        };
    });
}
exports.default = default_1;
//# sourceMappingURL=generator.js.map